Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 18132)
@@ -33,6 +33,6 @@
   [StorableType("D7186DFF-1596-4A58-B27D-974DF0D93E4F")]
   public sealed class SymbolicDataAnalysisExpressionLatexFormatter : NamedItem, ISymbolicExpressionTreeStringFormatter {
-    private readonly List<KeyValuePair<string, double>> constants;
-    private int constIndex;
+    private readonly List<KeyValuePair<string, double>> parameters;
+    private int paramIdx;
     private int targetCount;
     private int currentLag;
@@ -44,6 +44,6 @@
     private SymbolicDataAnalysisExpressionLatexFormatter(SymbolicDataAnalysisExpressionLatexFormatter original, Cloner cloner)
       : base(original, cloner) {
-      constants = new List<KeyValuePair<string, double>>(original.constants);
-      constIndex = original.constIndex;
+      parameters = new List<KeyValuePair<string, double>>(original.parameters);
+      paramIdx = original.paramIdx;
       currentLag = original.currentLag;
       targetCount = original.targetCount;
@@ -53,5 +53,5 @@
       Name = ItemName;
       Description = ItemDescription;
-      constants = new List<KeyValuePair<string, double>>();
+      parameters = new List<KeyValuePair<string, double>>();
     }
 
@@ -66,6 +66,6 @@
       try {
         StringBuilder strBuilder = new StringBuilder();
-        constants.Clear();
-        constIndex = 0;
+        parameters.Clear();
+        paramIdx = 0;
         this.targetVariable = targetVariable;
         containsTimeSeriesSymbol = symbolicExpressionTree.IterateNodesBreadth().Any(n => IsTimeSeriesSymbol(n.Symbol));
@@ -189,31 +189,30 @@
       } else if (node.Symbol is IfThenElse) {
         strBuilder.Append(@" \operatorname{if}  \left( ");
-      } else if (node.Symbol is Constant) {
-        var constName = "c_{" + constIndex + "}";
-        constIndex++;
-        var constNode = node as ConstantTreeNode;
-        if (constNode.Value.IsAlmost(1.0)) {
+      } else if (node.Symbol is INumericSymbol numSy) {
+        var numName = "c_{" + paramIdx + "}";
+        paramIdx++;
+        var numericNode = node as INumericTreeNode;
+        if (numericNode.Value.IsAlmost(1.0)) {
           strBuilder.Append("1 ");
         } else {
-          strBuilder.Append(constName);
-          constants.Add(new KeyValuePair<string, double>(constName, constNode.Value));
-        }
-
+          strBuilder.Append(numName);
+          parameters.Add(new KeyValuePair<string, double>(numName, numericNode.Value));
+        }
       } else if (node.Symbol is FactorVariable) {
         var factorNode = node as FactorVariableTreeNode;
-        var constName = "c_{" + constIndex + "}";
-        strBuilder.Append(constName + " ");
+        var paramName = "c_{" + paramIdx + "}";
+        strBuilder.Append(paramName + " ");
         foreach (var e in factorNode.Symbol.GetVariableValues(factorNode.VariableName)
           .Zip(factorNode.Weights, Tuple.Create)) {
-          constants.Add(new KeyValuePair<string, double>("c_{" + constIndex + ", " + EscapeLatexString(factorNode.VariableName) + "=" + EscapeLatexString(e.Item1) + "}", e.Item2));
-        }
-        constIndex++;
+          parameters.Add(new KeyValuePair<string, double>("c_{" + paramIdx + ", " + EscapeLatexString(factorNode.VariableName) + "=" + EscapeLatexString(e.Item1) + "}", e.Item2));
+        }
+        paramIdx++;
       } else if (node.Symbol is BinaryFactorVariable) {
         var binFactorNode = node as BinaryFactorVariableTreeNode;
         if (!binFactorNode.Weight.IsAlmost((1.0))) {
-          var constName = "c_{" + constIndex + "}";
-          strBuilder.Append(constName + "  \\cdot");
-          constants.Add(new KeyValuePair<string, double>(constName, binFactorNode.Weight));
-          constIndex++;
+          var paramName = "c_{" + paramIdx + "}";
+          strBuilder.Append(paramName + "  \\cdot");
+          parameters.Add(new KeyValuePair<string, double>(paramName, binFactorNode.Weight));
+          paramIdx++;
         }
         strBuilder.Append("(" + EscapeLatexString(binFactorNode.VariableName));
@@ -223,8 +222,8 @@
         var laggedVarNode = node as LaggedVariableTreeNode;
         if (!laggedVarNode.Weight.IsAlmost(1.0)) {
-          var constName = "c_{" + constIndex + "}";
-          strBuilder.Append(constName + "  \\cdot");
-          constants.Add(new KeyValuePair<string, double>(constName, laggedVarNode.Weight));
-          constIndex++;
+          var paramName = "c_{" + paramIdx + "}";
+          strBuilder.Append(paramName + "  \\cdot");
+          parameters.Add(new KeyValuePair<string, double>(paramName, laggedVarNode.Weight));
+          paramIdx++;
         }
         strBuilder.Append(EscapeLatexString(laggedVarNode.VariableName));
@@ -234,8 +233,8 @@
         var varNode = node as VariableTreeNode;
         if (!varNode.Weight.IsAlmost((1.0))) {
-          var constName = "c_{" + constIndex + "}";
-          strBuilder.Append(constName + "  \\cdot");
-          constants.Add(new KeyValuePair<string, double>(constName, varNode.Weight));
-          constIndex++;
+          var paramName = "c_{" + paramIdx + "}";
+          strBuilder.Append(paramName + "  \\cdot");
+          parameters.Add(new KeyValuePair<string, double>(paramName, varNode.Weight));
+          paramIdx++;
         }
         strBuilder.Append(EscapeLatexString(varNode.VariableName));
@@ -271,12 +270,12 @@
       } else if (node.Symbol is VariableCondition) {
         var conditionTreeNode = node as VariableConditionTreeNode;
-        var constName = "c_{" + constants.Count + "}";
-        string p = @"1 /  1 + \exp  - " + constName + " ";
-        constants.Add(new KeyValuePair<string, double>(constName, conditionTreeNode.Slope));
-        constIndex++;
-        var const2Name = "c_{" + constants.Count + @"}";
+        var paramName = "c_{" + parameters.Count + "}";
+        string p = @"1 /  1 + \exp  - " + paramName + " ";
+        parameters.Add(new KeyValuePair<string, double>(paramName, conditionTreeNode.Slope));
+        paramIdx++;
+        var const2Name = "c_{" + parameters.Count + @"}";
         p += @" \cdot " + EscapeLatexString(conditionTreeNode.VariableName) + LagToString(currentLag) + " - " + const2Name + "   ";
-        constants.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
-        constIndex++;
+        parameters.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
+        paramIdx++;
         strBuilder.Append(@" \left( " + p + @"\cdot ");
       } else {
@@ -379,12 +378,12 @@
       } else if (node.Symbol is VariableCondition) {
         var conditionTreeNode = node as VariableConditionTreeNode;
-        var const1Name = "c_{" + constants.Count + "}";
+        var const1Name = "c_{" + parameters.Count + "}";
         string p = @"1 / \left( 1 + \exp \left( - " + const1Name + " ";
-        constants.Add(new KeyValuePair<string, double>(const1Name, conditionTreeNode.Slope));
-        constIndex++;
-        var const2Name = "c_{" + constants.Count + "}";
+        parameters.Add(new KeyValuePair<string, double>(const1Name, conditionTreeNode.Slope));
+        paramIdx++;
+        var const2Name = "c_{" + parameters.Count + "}";
         p += @" \cdot " + EscapeLatexString(conditionTreeNode.VariableName) + LagToString(currentLag) + " - " + const2Name + " \right) \right) \right)   ";
-        constants.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
-        constIndex++;
+        parameters.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
+        paramIdx++;
         strBuilder.Append(@" +  \left( 1 - " + p + @" \right) \cdot ");
       } else {
@@ -471,4 +470,5 @@
       } else if (node.Symbol is IfThenElse) {
         strBuilder.Append(@" \right) ");
+      } else if (node.Symbol is Number) {
       } else if (node.Symbol is Constant) {
       } else if (node.Symbol is LaggedVariable) {
@@ -481,12 +481,12 @@
           .AppendLine("\\begin{align*}")
           .AppendLine("\\nonumber");
-        // output all constant values
-        if (constants.Count > 0) {
-          foreach (var constant in constants) {
+        // output all parameter values
+        if (parameters.Count > 0) {
+          foreach (var param in parameters) {
             // replace "." with ".&" to align decimal points
-            var constStr = string.Format(System.Globalization.NumberFormatInfo.InvariantInfo, "{0:G5}", constant.Value);
-            if (!constStr.Contains(".")) constStr = constStr + ".0";
-            constStr = constStr.Replace(".", "&.");  // fix problem in rendering of aligned expressions
-            strBuilder.Append(constant.Key + "& = & " + constStr);
+            var paramStr = string.Format(System.Globalization.NumberFormatInfo.InvariantInfo, "{0:G5}", param.Value);
+            if (!paramStr.Contains(".")) paramStr = paramStr + ".0";
+            paramStr = paramStr.Replace(".", "&.");  // fix problem in rendering of aligned expressions
+            strBuilder.Append(param.Key + "& = & " + paramStr);
             strBuilder.Append(@"\\");
           }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMATLABFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMATLABFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMATLABFormatter.cs	(revision 18132)
@@ -151,7 +151,7 @@
         }
         stringBuilder.Append(")");
-      } else if (symbol is Constant) {
-        ConstantTreeNode constantTreeNode = node as ConstantTreeNode;
-        stringBuilder.Append(constantTreeNode.Value.ToString(CultureInfo.InvariantCulture));
+      } else if (symbol is INumericSymbol) {
+        var numberTreeNode = node as INumericTreeNode;
+        stringBuilder.Append(numberTreeNode.Value.ToString(CultureInfo.InvariantCulture));
       } else if (symbol is Cosine) {
         stringBuilder.Append("cos(");
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMathematicaFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMathematicaFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMathematicaFormatter.cs	(revision 18132)
@@ -130,7 +130,7 @@
           var varNode = node as VariableTreeNode;
           strBuilder.AppendFormat("Times[{0}, {1}]", varNode.VariableName, varNode.Weight.ToString("G17", CultureInfo.InvariantCulture));
-        } else if (node.Symbol is Constant) {
-          var constNode = node as ConstantTreeNode;
-          strBuilder.Append(constNode.Value.ToString("G17", CultureInfo.InvariantCulture));
+        } else if (node.Symbol is INumericSymbol) {
+          var numNode = node as INumericTreeNode;
+          strBuilder.Append(numNode.Value.ToString("G17", CultureInfo.InvariantCulture));
         } else if (node.Symbol is FactorVariable) {
           var factorNode = node as FactorVariableTreeNode;
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs	(revision 18132)
@@ -202,6 +202,6 @@
       else if (node is VariableTreeNode)
         FormatVariableTreeNode(node, strBuilder);
-      else if (node is ConstantTreeNode)
-        FormatConstantTreeNode(node, strBuilder);
+      else if (node is INumericTreeNode)
+        FormatNumericTreeNode(node, strBuilder);
       else
         throw new NotSupportedException("Formatting of symbol: " + symbol + " not supported for Python symbolic expression tree formatter.");
@@ -227,7 +227,11 @@
     }
 
-    private static void FormatConstantTreeNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
-      var constNode = node as ConstantTreeNode;
-      strBuilder.Append(constNode.Value.ToString("g17", CultureInfo.InvariantCulture));
+    private static void FormatNumericTreeNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
+      var symbol = node.Symbol;
+      if (node is INumericTreeNode numNode) {
+        strBuilder.Append(numNode.Value.ToString("g17", CultureInfo.InvariantCulture));
+      } else {
+        throw new NotSupportedException("Formatting of symbol: " + symbol + " not supported for Python symbolic expression tree formatter.");
+      }
     }
 
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionSmalltalkFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionSmalltalkFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionSmalltalkFormatter.cs	(revision 18132)
@@ -83,7 +83,7 @@
         }
         stringBuilder.Append(")");
-      } else if (symbol is Constant) {
-        ConstantTreeNode constantTreeNode = node as ConstantTreeNode;
-        stringBuilder.Append(constantTreeNode.Value.ToString(CultureInfo.InvariantCulture));
+      } else if (symbol is INumericSymbol) {
+        var numberTreeNode = node as INumericTreeNode;
+        stringBuilder.Append(numberTreeNode.Value.ToString(CultureInfo.InvariantCulture));
       } else if (symbol is Cosine) {
         stringBuilder.Append(FormatRecursively(node.GetSubtree(0)));
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/TSQLExpressionFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/TSQLExpressionFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/TSQLExpressionFormatter.cs	(revision 18132)
@@ -93,8 +93,8 @@
       //Generate function header
       strBuilder.Append("CREATE FUNCTION dbo.REGRESSIONMODEL(");
-      strBuilder.Append(string.Join(", ", sortedVarcharIdentifiers.Select(n => string.Format("{0} NVARCHAR(max)",n))));
+      strBuilder.Append(string.Join(", ", sortedVarcharIdentifiers.Select(n => string.Format("{0} NVARCHAR(max)", n))));
       if (varcharVarNames.Any() && floatVarNames.Any())
         strBuilder.Append(",");
-      strBuilder.Append(string.Join(", ", sortedFloatIdentifiers.Select(n => string.Format("{0} FLOAT",n))));
+      strBuilder.Append(string.Join(", ", sortedFloatIdentifiers.Select(n => string.Format("{0} FLOAT", n))));
       strBuilder.AppendLine(")");
 
@@ -164,7 +164,6 @@
           var varNode = node as VariableTreeNode;
           strBuilder.AppendFormat("{0} * {1}", VariableName2Identifier(varNode.VariableName), varNode.Weight.ToString("g17", CultureInfo.InvariantCulture));
-        } else if (node is ConstantTreeNode) {
-          var constNode = node as ConstantTreeNode;
-          strBuilder.Append(constNode.Value.ToString("g17", CultureInfo.InvariantCulture));
+        } else if (node is INumericTreeNode numNode) {
+          strBuilder.Append(numNode.Value.ToString("g17", CultureInfo.InvariantCulture));
         } else if (node.Symbol is FactorVariable) {
           var factorNode = node as FactorVariableTreeNode;
@@ -181,7 +180,7 @@
     private void FormatIfThenElse(int level, ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
       strBuilder.Append("CASE ISNULL((SELECT 1 WHERE");
-      FormatRecursively(level,node.GetSubtree(0), strBuilder);
+      FormatRecursively(level, node.GetSubtree(0), strBuilder);
       strBuilder.AppendLine("),0)");
-      strBuilder.AppendIndented(level,"WHEN 1 THEN ");
+      strBuilder.AppendIndented(level, "WHEN 1 THEN ");
       FormatRecursively(level, node.GetSubtree(1), strBuilder);
       strBuilder.AppendLine();
@@ -203,5 +202,5 @@
 
     private string VariableName2Identifier(string variableName) {
-      return "@"+variableName.Replace(' ', '_');
+      return "@" + variableName.Replace(' ', '_');
     }
 
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs	(revision 18132)
@@ -49,12 +49,14 @@
       var mul = new Multiplication();
       var div = new Division();
+      var number = new Number();
+      number.MinValue = -20;
+      number.MaxValue = 20;
       var constant = new Constant();
-      constant.MinValue = -20;
-      constant.MaxValue = 20;
+      constant.Enabled = false;
       var variableSymbol = new HeuristicLab.Problems.DataAnalysis.Symbolic.Variable();
       var binFactorVariableSymbol = new BinaryFactorVariable();
       var factorVariableSymbol = new FactorVariable();
 
-      var allSymbols = new List<Symbol>() { add, sub, mul, div, constant, variableSymbol, binFactorVariableSymbol, factorVariableSymbol };
+      var allSymbols = new List<Symbol>() { add, sub, mul, div, number, constant, variableSymbol, binFactorVariableSymbol, factorVariableSymbol };
       var functionSymbols = new List<Symbol>() { add, sub, mul, div };
 
@@ -65,4 +67,5 @@
         SetSubtreeCount(funSymb, 1, 3);
       }
+      SetSubtreeCount(number, 0, 0);
       SetSubtreeCount(constant, 0, 0);
       SetSubtreeCount(variableSymbol, 0, 0);
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs	(revision 18132)
@@ -118,7 +118,7 @@
       variableCondition.InitialFrequency = 0.0;
 
-      var constant = new Constant();
-      constant.MinValue = -20;
-      constant.MaxValue = 20;
+      var number = new Number();
+      number.MinValue = -20;
+      number.MaxValue = 20;
       var variableSymbol = new HeuristicLab.Problems.DataAnalysis.Symbolic.Variable();
       var binFactorVariable = new BinaryFactorVariable();
@@ -130,7 +130,10 @@
       autoregressiveVariable.Enabled = false;
 
+      var constant = new Constant();
+      constant.Enabled = false;
+
       var allSymbols = new List<Symbol>() { add, sub, mul, div, aq, mean, abs, sin, cos, tan, log, square, cube, pow, sqrt, cubeRoot, root, exp, tanh,
         airyA, airyB, bessel, cosineIntegral, dawson, erf, expIntegralEi, fresnelCosineIntegral, fresnelSineIntegral, gamma, hypCosineIntegral, hypSineIntegral, norm, psi, sineIntegral,
-        @if, gt, lt, and, or, not,xor, timeLag, integral, derivative, constant, variableSymbol, binFactorVariable, factorVariable, laggedVariable,autoregressiveVariable, variableCondition };
+        @if, gt, lt, and, or, not,xor, timeLag, integral, derivative, number, constant, variableSymbol, binFactorVariable, factorVariable, laggedVariable,autoregressiveVariable, variableCondition };
       var unaryFunctionSymbols = new List<Symbol>() { abs, square, sqrt, cube, cubeRoot, sin, cos, tan, log, exp, tanh, not, timeLag, integral, derivative,
         airyA, airyB, bessel, cosineIntegral, dawson, erf, expIntegralEi, fresnelCosineIntegral, fresnelSineIntegral, gamma, hypCosineIntegral, hypSineIntegral, norm, psi, sineIntegral
@@ -139,5 +142,5 @@
       var binaryFunctionSymbols = new List<Symbol>() { pow, root, gt, lt, aq, variableCondition };
       var ternarySymbols = new List<Symbol>() { add, sub, mul, div, mean, and, or, xor };
-      var terminalSymbols = new List<Symbol>() { variableSymbol, binFactorVariable, factorVariable, constant, laggedVariable, autoregressiveVariable };
+      var terminalSymbols = new List<Symbol>() { variableSymbol, binFactorVariable, factorVariable, number, constant, laggedVariable, autoregressiveVariable };
 
       foreach (var symb in allSymbols)
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/LinearScalingGrammar.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/LinearScalingGrammar.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/LinearScalingGrammar.cs	(revision 18132)
@@ -66,7 +66,9 @@
       var abs = new Absolute();
       var aq = new AnalyticQuotient();
+      var number = new Number();
+      number.MinValue = -20;
+      number.MaxValue = 20;
       var constant = new Constant();
-      constant.MinValue = -20;
-      constant.MaxValue = 20;
+      constant.Enabled = false;
       var variableSymbol = new Variable();
 
@@ -78,5 +80,5 @@
       //all other symbols
       var allSymbols = new List<Symbol> {
-        add, sub, mul, div, constant, variableSymbol, sin, cos, tan, log, square, sqrt, cube, cbrt, exp,
+        add, sub, mul, div, number, constant, variableSymbol, sin, cos, tan, log, square, sqrt, cube, cbrt, exp,
         tanh, aq, abs
       };
@@ -86,5 +88,5 @@
       var realValueSymbols = new List<Symbol> {
          add, sub, mul, div, sin, cos, tan, tanh, exp, log, aq, abs, square, cube, sqrt, cbrt,
-         variableSymbol, constant,
+         variableSymbol, number, constant
         };
 
@@ -113,9 +115,9 @@
       //Define childs for offset
       AddAllowedChildSymbol(offset, scaling, 0);
-      AddAllowedChildSymbol(offset, constant, 1);
+      AddAllowedChildSymbol(offset, number, 1);
 
       //Define childs for scaling
       foreach (var symb in allSymbols) AddAllowedChildSymbol(scaling, symb, 0);
-      AddAllowedChildSymbol(scaling, constant, 1);
+      AddAllowedChildSymbol(scaling, number, 1);
 
       //Define childs for realvalue symbols
@@ -129,4 +131,5 @@
       Symbols.First(s => s is CubeRoot).Enabled = false;
       Symbols.First(s => s is Absolute).Enabled = false;
+      Symbols.First(s => s is Constant).Enabled = false;
     }
   }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 18132)
@@ -105,7 +105,9 @@
       var derivative = new Derivative();
 
+      var number = new Number();
+      number.MinValue = -20;
+      number.MaxValue = 20;
       var constant = new Constant();
-      constant.MinValue = -20;
-      constant.MaxValue = 20;
+      constant.Enabled = false;
       var variableSymbol = new Variable();
       var binFactorVariable = new BinaryFactorVariable();
@@ -121,5 +123,5 @@
       var specialFunctions = new GroupSymbol(SpecialFunctionsName, new List<ISymbol> { abs, airyA, airyB, bessel, cosineIntegral, dawson, erf, expIntegralEi,
         fresnelCosineIntegral,fresnelSineIntegral,gamma,hypCosineIntegral,hypSineIntegral,norm, psi, sineIntegral, analyticalQuotient});
-      var terminalSymbols = new GroupSymbol(TerminalsName, new List<ISymbol> { constant, variableSymbol, binFactorVariable, factorVariable });
+      var terminalSymbols = new GroupSymbol(TerminalsName, new List<ISymbol> { number, constant, variableSymbol, binFactorVariable, factorVariable });
       var realValuedSymbols = new GroupSymbol(RealValuedSymbolsName, new List<ISymbol>() { arithmeticSymbols, trigonometricSymbols, exponentialAndLogarithmicSymbols, specialFunctions, terminalSymbols });
 
@@ -193,4 +195,5 @@
       AddAllowedChildSymbol(powerSymbols, laggedVariable, 0);
       AddAllowedChildSymbol(powerSymbols, autoregressiveVariable, 0);
+      AddAllowedChildSymbol(powerSymbols, number, 1);
       AddAllowedChildSymbol(powerSymbols, constant, 1);
 
@@ -249,4 +252,5 @@
       Symbols.First(s => s.Name == ConditionalSymbolsName).Enabled = false;
       Symbols.First(s => s.Name == TimeSeriesSymbolsName).Enabled = false;
+      Symbols.First(s => s is Constant).Enabled = false;
     }
 
@@ -262,4 +266,5 @@
       Symbols.First(s => s.Name == PowerFunctionsName).Enabled = false;
       Symbols.First(s => s.Name == TimeSeriesSymbolsName).Enabled = false;
+      Symbols.First(s => s is Constant).Enabled = false;
     }
 
@@ -278,4 +283,5 @@
       Symbols.First(s => s is Integral).Enabled = false;
       Symbols.First(s => s is TimeLag).Enabled = false;
+      Symbols.First(s => s is Constant).Enabled = false;
     }
   }
